SystemOrganization addCategory: #GOODSTrackingCollections!

Dictionary subclass: #KKDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSTrackingCollections'!

!KKDictionary commentStamp: 'cds 10/24/2010 12:06' prior: 0!
I am a Dictionary that can be used in a GOODS database that is tracking changes with the manual write barrier.  See KKManualWriteBarrier.!

!KKDictionary methodsFor: 'adding' stamp: 'AndyKellens 6/30/2010 23:03'!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element goodsChanged. element value: anAssociation value].
	^ anAssociation! !

!KKDictionary methodsFor: 'accessing' stamp: 'AndyKellens 9/16/2010 19:27'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (Association key: key value: anObject)]
		ifNotNil: [assoc goodsChanged. assoc value: anObject].
	^ anObject! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/22/2010 22:15'!
atNewIndex: index put: anObject
	super atNewIndex: index put: anObject.
	self goodsChanged ! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/22/2010 22:06'!
fixCollisionsFrom: start
	super fixCollisionsFrom: start.
	self goodsChanged! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/22/2010 22:25'!
goodsChanged 
	super goodsChanged.
	array goodsChanged.
	tally goodsChanged! !

!KKDictionary methodsFor: 'testing' stamp: 'AndyKellens 6/5/2010 13:33'!
goodsHasChangeTracking 
	^true! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/22/2010 22:14'!
grow 
	super grow.
	self goodsChanged ! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/22/2010 22:14'!
initialize: n
	super initialize: n.
	self goodsChanged! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:46'!
noCheckAdd: anObject
	super noCheckAdd: anObject.
	self goodsChanged! !

!KKDictionary methodsFor: 'copying' stamp: 'AndyKellens 6/22/2010 22:07'!
postCopy 
	super postCopy.
	self goodsChanged! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:46'!
rehash 
	super rehash.
	self goodsChanged! !

!KKDictionary methodsFor: 'removing' stamp: 'AndyKellens 6/5/2010 09:47'!
removeKey: key ifAbsent: aBlock
	| result |
	result := super removeKey: key ifAbsent: aBlock.
	self goodsChanged.
	^result! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:45'!
species 
	^KKDictionary! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/30/2010 22:57'!
swap: oneIndex with: otherIndex
	super swap: oneIndex with: otherIndex.
	self goodsChanged! !

!KKDictionary methodsFor: 'private' stamp: 'AndyKellens 6/30/2010 22:57'!
withArray: anArray
	super withArray: anArray.
	self goodsChanged! !

Set subclass: #KKSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSTrackingCollections'!

!KKSet commentStamp: 'cds 10/24/2010 12:06' prior: 0!
I am a Set that can be used in a GOODS database that is tracking changes with the manual write barrier.  See KKManualWriteBarrier.!

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:38'!
atNewIndex: index put: anObject
	super atNewIndex: index put: anObject.
	self goodsChanged ! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/22/2010 22:02'!
fixCollisionsFrom: start
	super fixCollisionsFrom: start.
	self goodsChanged! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/30/2010 23:17'!
goodsChanged 
	array goodsChanged.
	tally goodsChanged.
	super goodsChanged! !

!KKSet methodsFor: 'testing' stamp: 'AndyKellens 6/5/2010 13:30'!
goodsHasChangeTracking 
	^true! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:38'!
grow 
	super grow.
	self goodsChanged! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:39'!
initialize: n
	super initialize:n.
	self goodsChanged! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:39'!
noCheckAdd: anObject
	super noCheckAdd: anObject.
	self goodsChanged! !

!KKSet methodsFor: 'copy' stamp: 'AndyKellens 6/22/2010 22:04'!
postCopy 
	super postCopy.
	self goodsChanged! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:39'!
rehash
	super rehash.
	self goodsChanged! !

!KKSet methodsFor: 'removing' stamp: 'AndyKellens 6/5/2010 09:41'!
remove: oldObject ifAbsent: aBlock
	| result |
	result := super remove: oldObject ifAbsent: aBlock.
	self goodsChanged.
	^result! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:40'!
species
	^KKSet! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:40'!
swap: oneIndex with: otherIndex
	super swap: oneIndex with: otherIndex.
	self goodsChanged! !

!KKSet methodsFor: 'private' stamp: 'AndyKellens 6/5/2010 09:40'!
withArray: anArray
	super withArray: anArray.
	self goodsChanged! !

OrderedCollection subclass: #KKOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSTrackingCollections'!

!KKOrderedCollection commentStamp: 'cds 10/24/2010 12:06' prior: 0!
I am an OrderedCollection that can be used in a GOODS database that is tracking changes with the manual write barrier.  See KKManualWriteBarrier.!

!KKOrderedCollection methodsFor: 'adding' stamp: 'AndyKellens 6/5/2010 09:35'!
addFirst: newObject
	| result |
	result := super addFirst: newObject.
	self goodsChanged.
	^result! !

!KKOrderedCollection methodsFor: 'adding' stamp: 'AndyKellens 6/5/2010 09:35'!
addLast: newObject
	| result |
	result := super addLast: newObject.
	self goodsChanged.
	^result! !

!KKOrderedCollection methodsFor: 'accessing' stamp: 'AndyKellens 6/5/2010 09:25'!
at: anInteger put: anObject
	| result |
	result := super at: anInteger put: anObject.
	self goodsChanged.
	^result! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:24'!
goodsChanged 
	super goodsChanged.
	array goodsChanged! !

!KKOrderedCollection methodsFor: 'testing' stamp: 'AndyKellens 6/5/2010 13:30'!
goodsHasChangeTracking 
	^true! !

!KKOrderedCollection methodsFor: 'adding' stamp: 'AndyKellens 6/5/2010 09:35'!
grow 
	super grow.
	self goodsChanged ! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:27'!
insert: anObject before: spot
	| result |
	result := super insert: anObject before: spot.
	self goodsChanged.
	^result! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:29'!
makeRoomAtFirst
	super makeRoomAtFirst.
	self goodsChanged! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:29'!
makeRoomAtLast
	super makeRoomAtLast.
	self goodsChanged! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/22/2010 21:52'!
makeRoomFor: anInteger
	| newArray |

	(self capacity - firstIndex - 1 - self size) >= anInteger
		ifTrue: [^self].

	newArray := Array new: self size + (self growSizeGuaranteeing: anInteger).
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray.
	self goodsChanged.
	^ self! !

!KKOrderedCollection methodsFor: 'copying' stamp: 'AndyKellens 6/5/2010 09:34'!
postCopyFrom: startIndex to: endIndex
	super postCopyFrom: startIndex to:endIndex.
	self goodsChanged.
	! !

!KKOrderedCollection methodsFor: 'removing' stamp: 'AndyKellens 6/5/2010 09:31'!
removeAllSuchThat: aBlock
	super removeAllSuchThat: aBlock.
	self goodsChanged! !

!KKOrderedCollection methodsFor: 'removing' stamp: 'AndyKellens 6/5/2010 09:32'!
removeFirst 
	| result |
	result := super removeFirst.
	self goodsChanged.
	^result! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:29'!
removeIndex: removedIndex
	super removeIndex: removedIndex.
	self goodsChanged! !

!KKOrderedCollection methodsFor: 'removing' stamp: 'AndyKellens 6/5/2010 09:32'!
removeLast
	| result |
	result := super removeLast.
	self goodsChanged.
	^result! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/22/2010 21:57'!
replaceFrom: start to: stop with: replacement startingAt: repStart
	"An ordered collection is growable, so a call to this can make the collection grow."
	self makeRoomFor: (stop - self capacity).
	array
		replaceFrom: start + firstIndex - 1
		to: stop + firstIndex - 1
		with: replacement 
		startingAt: repStart.
	lastIndex := lastIndex max: stop + firstIndex - 1.
	self goodsChanged ! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:30'!
reset
	super reset.
	self goodsChanged ! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:30'!
resetTo: index 
	super resetTo: index.
	self goodsChanged! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:30'!
setCollection: anArray
	super setCollection: anArray.
	self goodsChanged! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:30'!
setContents: anArray
	super setContents: anArray.
	self goodsChanged! !

!KKOrderedCollection methodsFor: 'enumerating' stamp: 'AndyKellens 6/22/2010 21:58'!
sort: aBlock
	super sort: aBlock.
	self goodsChanged ! !

!KKOrderedCollection methodsFor: 'private ' stamp: 'AndyKellens 6/5/2010 09:37'!
species 
	^KKOrderedCollection ! !
